// Gray - A simple ray tracing program
// Copyright (C) 2008-2018 Eric Bechet
//
// See the COPYING file for contributions and license information.
// Please report all bugs and problems to <bechet@cadxfem.org>.
//

#ifndef __GLFRAMEBUFFER_H_
#define __GLFRAMEBUFFER_H_

#include <ostream>
#include "framebuffer.h"
#include "fltkdisplay.h"
#include "nglwindow.h"

//class MyGlWindow;

class gl_framebuffer : public basic_framebuffer, public fltkdisplay
{
public:
  gl_framebuffer ( size_t w_,size_t h_ ,Gscene *sc_ ) : basic_framebuffer ( w_,h_,sc_ ),ogl(NULL) {}
  virtual ~gl_framebuffer() {}
  void setogl ( nglwindow *w )
  {
    ogl=w;
  }
  void get_coords ( GLfloat i,GLfloat j, Ray & r );
  virtual void draw_model(int mode=DRAW_NORMAL);
  virtual void draw_pixmap(void);
  virtual int handle(int event);
  virtual void display(bool perspectiveon=0);   // display loop
private:
  nglwindow *ogl;
};

#endif // __GLFRAMEBUFFER_H_
// kate: indent-mode cstyle; indent-width 2; replace-tabs on; 
