// Gray - A simple ray tracing program
// Copyright (C) 2008-2018 Eric Bechet
//
// See the COPYING file for contributions and license information.
// Please report all bugs and problems to <bechet@cadxfem.org>.
//

#include "nbeziercurve.h"
#include "nutil.h"
#include "gnurbs-interface.h"
#include <iostream>

void test ( void )
{
  nbeziercurve bez ( 5 );
  bez.CP ( 0 ) =npoint ( 0,0,0 );
  bez.CP ( 1 ) =npoint ( 1,0,0 );
  bez.CP ( 2 ) =npoint ( 1,1,0 );
  bez.CP ( 3 ) =npoint ( 0,2,0 );
  bez.CP ( 4 ) =npoint ( 0,4,0 );
  nbeziercurve dbez ( 4 );
  dbez.CP ( 0 ) =npoint ( 4.,0,0 );
  dbez.CP ( 1 ) =npoint ( 0,4.,0 );
  dbez.CP ( 2 ) =npoint ( -4.,4.,0 );
  dbez.CP ( 3 ) =npoint ( 0,8.,0 );
  nbeziercurve d2bez ( 3 );
  d2bez.CP ( 0 ) =npoint ( -12.,12,0 );
  d2bez.CP ( 1 ) =npoint ( -12.,0.,0 );
  d2bez.CP ( 2 ) =npoint ( 12.,12.,0 );

  
  npoint res;
  bez.P ( 0.5,res );
  npoint derres;
  bez.dPdu ( 0.5,derres );
  npoint der2res;
  bez.d2Pdu2 ( 0.5,der2res );
  npoint derres2;
  dbez.P( 0.5,derres2 );
  npoint der2res2;
  d2bez.P( 0.5,der2res2 );
  std::cout << res[0]-0.625 << " " << res[1]-1.125 << " " << res[2] << std::endl;
  std::cout << derres[0]+1 << " " << derres[1]-4 << " " << derres[2] << std::endl;
  std::cout << derres2[0]+1 << " " << derres2[1]-4 << " " << derres2[2] << std::endl;
  std::cout << der2res[0]+6. << " " << der2res[1]-6 << " " << der2res[2] << std::endl;
  std::cout << der2res2[0]+6. << " " << der2res2[1]-6 << " " << der2res2[2] << std::endl;
}
// kate: indent-mode cstyle; indent-width 2; replace-tabs on; 
